Open CASCADE Technology: BRepFeat_MakePrism Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
BRepFeat_MakePrism Class Reference

Describes functions to build prism features. These can be depressions or protrusions. The semantics of prism feature creation is based on the construction of shapes: More...

`#include <BRepFeat_MakePrism.hxx>`

Inheritance diagram for BRepFeat_MakePrism:
[legend]

## Public Member Functions
| BRepFeat_MakePrism ()
| Builds a prism by projecting a wire along the face of a shape. Initializes the prism class. More...
| BRepFeat_MakePrism (const TopoDS_Shape &Sbase, const TopoDS_Shape &Pbase, const TopoDS_Face &Skface, const gp_Dir &Direction, const Standard_Integer Fuse, const Standard_Boolean Modify)
| Builds a prism by projecting a wire along the face of a shape. a face Pbase is selected in the shape Sbase to serve as the basis for the prism. The orientation of the prism will be defined by the vector Direction. Fuse offers a choice between: More...
void | Init (const TopoDS_Shape &Sbase, const TopoDS_Shape &Pbase, const TopoDS_Face &Skface, const gp_Dir &Direction, const Standard_Integer Fuse, const Standard_Boolean Modify)
| Initializes this algorithm for building prisms along surfaces. A face Pbase is selected in the shape Sbase to serve as the basis for the prism. The orientation of the prism will be defined by the vector Direction. Fuse offers a choice between: More...
void | Add (const TopoDS_Edge &E, const TopoDS_Face &OnFace)
| Indicates that the edge <E> will slide on the face <OnFace>. Raises ConstructionError if the face does not belong to the basis shape, or the edge to the prismed shape. More...
void | Perform (const Standard_Real Length)
void | Perform (const TopoDS_Shape &Until)
void | Perform (const TopoDS_Shape &From, const TopoDS_Shape &Until)
| Assigns one of the following semantics. More...
void | PerformUntilEnd ()
| Realizes a semi-infinite prism, limited by the position of the prism base. All other faces extend infinitely. More...
void | PerformFromEnd (const TopoDS_Shape &FUntil)
| Realizes a semi-infinite prism, limited by the face Funtil. More...
void | PerformThruAll ()
| Builds an infinite prism. The infinite descendants will not be kept in the result. More...
void | PerformUntilHeight (const TopoDS_Shape &Until, const Standard_Real Length)
| Assigns both a limiting shape, Until from TopoDS_Shape, and a height, Length at which to stop generation of the prism feature. More...
void | Curves (TColGeom_SequenceOfCurve &S)
| Returns the list of curves S parallel to the axis of the prism. More...
Handle< Geom_Curve > | BarycCurve ()
| Generates a curve along the center of mass of the primitive. More...
Public Member Functions inherited from BRepFeat_Form
virtual const TopTools_ListOfShape & | Modified (const TopoDS_Shape &F)
| returns the list of generated Faces. More...
virtual const TopTools_ListOfShape & | Generated (const TopoDS_Shape &S)
| returns a list of the created faces from the shape <S>. More...
virtual Standard_Boolean | IsDeleted (const TopoDS_Shape &S)
| Returns true if the shape S has been deleted. More...
const TopTools_ListOfShape & | FirstShape () const
| Returns the list of shapes created at the bottom of the created form. It may be an empty list. More...
const TopTools_ListOfShape & | LastShape () const
| Returns the list of shapes created at the top of the created form. It may be an empty list. More...
const TopTools_ListOfShape & | NewEdges () const
| Returns a list of the limiting and glueing edges generated by the feature. These edges did not originally exist in the basis shape. The list provides the information necessary for subsequent addition of fillets. It may be an empty list. More...
const TopTools_ListOfShape & | TgtEdges () const
| Returns a list of the tangent edges among the limiting and glueing edges generated by the feature. These edges did not originally exist in the basis shape and are tangent to the face against which the feature is built. The list provides the information necessary for subsequent addition of fillets. It may be an empty list. If an edge is tangent, no fillet is possible, and the edge must subsequently be removed if you want to add a fillet. More...
void | BasisShapeValid ()
| Initializes the topological construction if the basis shape is present. More...
void | GeneratedShapeValid ()
| Initializes the topological construction if the generated shape S is present. More...
void | ShapeFromValid ()
| Initializes the topological construction if the shape is present from the specified integer on. More...
void | ShapeUntilValid ()
| Initializes the topological construction if the shape is present until the specified integer. More...
void | GluedFacesValid ()
| Initializes the topological construction if the glued face is present. More...
void | SketchFaceValid ()
| Initializes the topological construction if the sketch face is present. If the sketch face is inside the basis shape, local operations such as glueing can be performed. More...
void | PerfSelectionValid ()
| Initializes the topological construction if the selected face is present. More...
BRepFeat_StatusError | CurrentStatusError () const
Public Member Functions inherited from BRepBuilderAPI_MakeShape
virtual void | Delete ()
virtual | ~BRepBuilderAPI_MakeShape ()
virtual void | Build ()
| This is called by Shape(). It does nothing but may be redefined. More...
virtual const TopoDS_Shape & | Shape () const
| Returns a shape built by the shape construction algorithm. Raises exception StdFail_NotDone if the shape was not built. More...
| operator TopoDS_Shape () const
Public Member Functions inherited from BRepBuilderAPI_Command
virtual | ~BRepBuilderAPI_Command ()
virtual Standard_Boolean | IsDone () const
void | Check () const
| Raises NotDone if done is false. More...

## Additional Inherited Members
Protected Member Functions inherited from BRepFeat_Form
| BRepFeat_Form ()
| Redefines the empty constructor. More...
void | GlobalPerform ()
| General perform method... More...
void | UpdateDescendants (const LocOpe_Gluer &G)
void | UpdateDescendants (const BRepAlgoAPI_BooleanOperation &aBOP, const TopoDS_Shape &SResult, const Standard_Boolean SkipFace=Standard_False)
void | UpdateDescendants (const Handle< TopOpeBRepBuild_HBuilder > &B, const TopoDS_Shape &SResult, const Standard_Boolean SkipFace=Standard_False)
Standard_Boolean | TransformShapeFU (const Standard_Integer flag)
Protected Member Functions inherited from BRepBuilderAPI_MakeShape
| BRepBuilderAPI_MakeShape ()
Protected Member Functions inherited from BRepBuilderAPI_Command
| BRepBuilderAPI_Command ()
| Set done to False. More...
void | Done ()
| Set done to true. More...
void | NotDone ()
| Set done to false. More...
Protected Attributes inherited from BRepFeat_Form
Standard_Boolean | myFuse
Standard_Boolean | myModify
TopTools_DataMapOfShapeListOfShape | myMap
TopoDS_Shape | myFShape
TopoDS_Shape | myLShape
TopTools_ListOfShape | myNewEdges
TopTools_ListOfShape | myTgtEdges
BRepFeat_PerfSelection | myPerfSelection
Standard_Boolean | myJustGluer
Standard_Boolean | myJustFeat
TopoDS_Shape | mySbase
TopoDS_Face | mySkface
TopoDS_Shape | myGShape
TopoDS_Shape | mySFrom
TopoDS_Shape | mySUntil
TopTools_DataMapOfShapeShape | myGluedF
Protected Attributes inherited from BRepBuilderAPI_MakeShape
TopoDS_Shape | myShape
TopTools_ListOfShape | myGenerated

## Detailed Description

Describes functions to build prism features. These can be depressions or protrusions. The semantics of prism feature creation is based on the construction of shapes:

- along a length
- up to a limiting face
- from a limiting face to a height. The shape defining construction of the prism feature can be either the supporting edge or the concerned area of a face. In case of the supporting edge, this contour can be attached to a face of the basis shape by binding. When the contour is bound to this face, the information that the contour will slide on the face becomes available to the relevant class methods. In case of the concerned area of a face, you could, for example, cut it out and move it to a different height which will define the limiting face of a protrusion or depression.

## Constructor & Destructor Documentation

BRepFeat_MakePrism::BRepFeat_MakePrism | ( |  | ) |

Builds a prism by projecting a wire along the face of a shape. Initializes the prism class.

BRepFeat_MakePrism::BRepFeat_MakePrism | ( | const TopoDS_Shape & | Sbase,
|  | const TopoDS_Shape & | Pbase,
|  | const TopoDS_Face & | Skface,
|  | const gp_Dir & | Direction,
|  | const Standard_Integer | Fuse,
|  | const Standard_Boolean | Modify
| ) |  |

Builds a prism by projecting a wire along the face of a shape. a face Pbase is selected in the shape Sbase to serve as the basis for the prism. The orientation of the prism will be defined by the vector Direction. Fuse offers a choice between:

- removing matter with a Boolean cut using the setting 0
- adding matter with Boolean fusion using the setting 1. The sketch face Skface serves to determine the type of operation. If it is inside the basis shape, a local operation such as glueing can be performed. Exceptions Standard_ConstructionError if the face does not belong to the basis or the prism shape.

## Member Function Documentation

void BRepFeat_MakePrism::Add | ( | const TopoDS_Edge & | E,
|  | const TopoDS_Face & | OnFace
| ) |  |

Indicates that the edge <E> will slide on the face <OnFace>. Raises ConstructionError if the face does not belong to the basis shape, or the edge to the prismed shape.

Handle< Geom_Curve > BRepFeat_MakePrism::BarycCurve | ( |  | ) |
| virtual

Generates a curve along the center of mass of the primitive.

Implements BRepFeat_Form.

void BRepFeat_MakePrism::Curves | ( | TColGeom_SequenceOfCurve & | S | ) |
| virtual

Returns the list of curves S parallel to the axis of the prism.

Implements BRepFeat_Form.

void BRepFeat_MakePrism::Init | ( | const TopoDS_Shape & | Sbase,
|  | const TopoDS_Shape & | Pbase,
|  | const TopoDS_Face & | Skface,
|  | const gp_Dir & | Direction,
|  | const Standard_Integer | Fuse,
|  | const Standard_Boolean | Modify
| ) |  |

Initializes this algorithm for building prisms along surfaces. A face Pbase is selected in the shape Sbase to serve as the basis for the prism. The orientation of the prism will be defined by the vector Direction. Fuse offers a choice between:

- removing matter with a Boolean cut using the setting 0
- adding matter with Boolean fusion using the setting 1. The sketch face Skface serves to determine the type of operation. If it is inside the basis shape, a local operation such as glueing can be performed.

void BRepFeat_MakePrism::Perform | ( | const Standard_Real | Length | ) |

void BRepFeat_MakePrism::Perform | ( | const TopoDS_Shape & | Until | ) |

void BRepFeat_MakePrism::Perform | ( | const TopoDS_Shape & | From,
|  | const TopoDS_Shape & | Until
| ) |  |

Assigns one of the following semantics.

- to a height Length
- to a face Until
- from a face From to a height Until. Reconstructs the feature topologically according to the semantic option chosen.

void BRepFeat_MakePrism::PerformFromEnd | ( | const TopoDS_Shape & | FUntil | ) |

Realizes a semi-infinite prism, limited by the face Funtil.

void BRepFeat_MakePrism::PerformThruAll | ( |  | ) |

Builds an infinite prism. The infinite descendants will not be kept in the result.

void BRepFeat_MakePrism::PerformUntilEnd | ( |  | ) |

Realizes a semi-infinite prism, limited by the position of the prism base. All other faces extend infinitely.

void BRepFeat_MakePrism::PerformUntilHeight | ( | const TopoDS_Shape & | Until,
|  | const Standard_Real | Length
| ) |  |

Assigns both a limiting shape, Until from TopoDS_Shape, and a height, Length at which to stop generation of the prism feature.

The documentation for this class was generated from the following file:

- BRepFeat_MakePrism.hxx